﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ResponsiveGrids.Controllers;
using Newtonsoft.Json;
using ResponsiveGrids.Models;

namespace ResponsiveGrids.Controllers
{
    public class HomeController : Controller
    {
        public static AdventureWorksModelContainer context = new AdventureWorksModelContainer();
        //
        // GET: /Home/

        public ActionResult Index()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Grids' Responsive Web Design Mode feature.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Grids' Responsive Web Design Mode feature.";
            return View();
        }

        public ActionResult MVCDemo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature. using the ASP.NET MVC helpers. Column Hiding is enabled. The hidden indicator is enlarged and Windows UI theme is applied for better usability touch devices. ";
            return View(context.People.Take(20));
        }

        public ActionResult HidingMVCDemo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature. using the ASP.NET MVC helpers. Column Hiding is enabled. The hidden indicator is hidden and instead external UI is provided to open the column chooser and additional logic to display hidden columns.";
            return View(context.People.Take(20));
        }

        public ActionResult Demo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature. Column Hiding is enabled. The hidden indicator is enlarged and Windows UI theme is applied for better usability touch devices. ";
            return View(context.People.Take(20));
        }

        public ActionResult HidingDemo()
        {
            ViewBag.Message = "Ignite UI Grid's Responsive Web Design Mode feature. Column Hiding is enabled. The hidden indicator is hidden and instead external UI is provided to open the column chooser and additional logic to display hidden columns.";
            return View(context.People.Take(20));
        }

        public ActionResult HMVCDemo()
        {
            ViewBag.Message = "Ignite UI Hierarchical Grid's  Responsive Web Design Mode feature. using the ASP.NET MVC helpers on both the parent and child layouts. Parent Uses multi-column headers and child layouts have a templated progress bar only in desktop mode.";
            /* Lie and cheat to make the Departments with Employees and also allow it be normally seriazable */
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).AsQueryable();
            return View(departments);
        }

        public ActionResult HDemo()
        {
            ViewBag.Message = "Ignite UI Hierarchical Grid's Responsive Web Design Mode feature. on both the parent and child layouts. Parent Uses multi-column headers and child layouts have a templated progress bar only in desktop mode.";
            return View();
        }

        public JsonResult Departments()
        {
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).ToList();
            return Json(departments, JsonRequestBehavior.AllowGet);
        }
    }
}
